unit ufrmMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Grids, Menus;

type
  TTablero = Array[0..8,0..8] of Integer;

  TfrmMain = class(TForm)
    grdTablero: TStringGrid;
    mnuMain: TMainMenu;
    mnuSudoku: TMenuItem;
    mnuNuevo: TMenuItem;
    mnuGenerar: TMenuItem;
    mnuGenSencillo: TMenuItem;
    mnuGenNormal: TMenuItem;
    mnuGenDificil: TMenuItem;
    N1: TMenuItem;
    mnuReducir: TMenuItem;
    mnuResolver: TMenuItem;
    N2: TMenuItem;
    mnuSalir: TMenuItem;
    mnuUndo: TMenuItem;
    N3: TMenuItem;
    mnuAbrir: TMenuItem;
    mnuGuardar: TMenuItem;
    dlgOpen: TOpenDialog;
    dlgSave: TSaveDialog;
    mnuComprobar: TMenuItem;
    mnuAyudame: TMenuItem;
    mnuPrint: TMenuItem;
    N4: TMenuItem;
    mnuJuego: TMenuItem;
    munAyuda: TMenuItem;
    munAcercade: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure grdTableroDrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure mnuNuevoClick(Sender: TObject);
    procedure mnuGenSencilloClick(Sender: TObject);
    procedure mnuReducirClick(Sender: TObject);
    procedure mnuResolverClick(Sender: TObject);
    procedure mnuSalirClick(Sender: TObject);
    procedure grdTableroMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure mnuUndoClick(Sender: TObject);
    procedure mnuGuardarClick(Sender: TObject);
    procedure mnuAbrirClick(Sender: TObject);
    procedure mnuComprobarClick(Sender: TObject);
    procedure mnuAyudameClick(Sender: TObject);
    procedure mnuPrintClick(Sender: TObject);
    procedure munAcercadeClick(Sender: TObject);
  private
    { Private declarations }
    procedure PaintTablero(Tablero: TTablero);
    procedure StringGridToTablero(var Tablero: TTablero);
    function TableroToString(Tablero: TTablero): string;
    procedure StringToTablero(Str: string; var Tablero: TTablero);
    procedure GuardarUndo;
    procedure Mensaje(Str: string);
    procedure Cargar(Filename: string);
  public
    { Public declarations }
    TableroGenerado: TTablero;
    UndoList: TStringList;
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.dfm}

uses Printers;

const
  NUM_FILAS = 9;
  NUM_COLUMNAS = 9;

function Fila(Tablero: TTablero; y,n: Integer): boolean;
var
  x: Integer;
begin
  Result:= TRUE;
  x:= 0;
  while (x < NUM_COLUMNAS) and Result do
  begin
    if Tablero[x,y] = n then
      Result:= FALSE;
    inc(x);
  end;
end;

function Columna(Tablero: TTablero; x,n: Integer): boolean;
var
  y: Integer;
begin
  Result:= TRUE;
  y:= 0;
  while (y < NUM_FILAS) and Result do
  begin
    if Tablero[x,y] = n then
      Result:= FALSE;
    inc(y);
  end;
end;

function Cuadrante(Tablero: TTablero; x,y,n: Integer): boolean;
var
 i,j: Integer;
begin
 Result:= TRUE;
 x:= (x div 3)*3;
 y:= (y div 3)*3;
 for j:= y to y + 2 do
   for i:= x to x + 2 do
     if Tablero[i,j] = n then
     begin
       Result:= FALSE;
       Exit;
     end;
end;

function Valido(Tablero: TTablero; x,y,n: Integer): boolean;
begin
  Result:= Fila(Tablero,y,n) and Columna(Tablero,x,n)
    and Cuadrante(Tablero,x,y,n);
end;

function Obvio(Tablero: TTablero; x,y: Integer): Integer;
var
 i,j,n: Integer;
begin
 j:= 0; n:= 0;
 for i:=1 to 9 do
   if Valido(Tablero,x,y,i) then
   begin
     n:= i;
     inc(j);
   end;
 if j=1 then
   Result:= n
 else
   Result:= 0;
end;

procedure Reducir(var Tablero: TTablero);
var
 x,y: Integer;
 Repetir: Boolean;
begin
 repeat
   Repetir:= FALSE;
   for y:= 0 to NUM_FILAS - 1 do
     for x:= 0 to NUM_COLUMNAS - 1 do
       if Tablero[x,y] = 0 then
       begin
         Tablero[x,y]:= Obvio(Tablero,x,y);
         if Tablero[x,y] > 0 then
           Repetir:= TRUE;
       end;
 until not Repetir;
end;

function Resolver(var Tablero: TTablero): Boolean;
var
 x,y,i: Integer;
begin
  Result:= TRUE;
  for y:= 0 to NUM_FILAS - 1 do
   for x:= 0 to NUM_COLUMNAS - 1 do
     if Tablero[x,y] = 0 then
     begin
       Result:= FALSE;
       for i:= 1 to 9 do
         if Valido(Tablero,x,y,i) then
         begin
           Tablero[x,y]:= i;
           if Resolver(Tablero) then
           begin
             Result:= TRUE;
             Exit;
           end else Tablero[x,y]:= 0;
         end;
       Exit;
     end;
end;

function Ayudita(var Tablero: TTablero): Boolean;
var
  i,j: Integer;
  T: TTablero;
begin
  Result:= FALSE;
  T:= Tablero;
  if Resolver(T) then
  begin
    for j:= 0 to NUM_FILAS - 1 do
      for i:= 0 to NUM_COLUMNAS - 1 do 
        if Tablero[i,j] <> T[i,j] then
        begin
          Tablero[i,j]:= T[i,j];
          Result:= TRUE;
          Exit;
        end;
  end;
end;

procedure GenerarTablero(var Tablero: TTablero; Dificultad: Integer);
var
  i,j,k,l: integer;
begin
  FillChar(Tablero,Sizeof(Tablero),0);
  Randomize;
  i:= 0;
  while i < NUM_COLUMNAS do
  begin
    j:= Random(9)+1;
    if Valido(Tablero, i, 0, j) then
    begin
      Tablero[i,0]:= j;
      inc(i)
    end;
  end;
  Resolver(Tablero);
  k:= 0;
  // Quitamos algunos obvios
  while k < 30 do
  begin
    i:= Random(NUM_COLUMNAS);
    j:= Random(NUM_FILAS);
    if Tablero[i,j] <> 0 then
    begin
      l:= Tablero[i,j];
      Tablero[i,j]:= 0;
      if Obvio(Tablero,i,j)>0 then
        inc(k)
      else
        Tablero[i,j]:= l;
    end;
  end;
  k:= 0;
  // Quitamos algunos que no son obvios
  while k < Dificultad do
  begin
    i:= Random(NUM_COLUMNAS);
    j:= Random(NUM_FILAS);
    if Tablero[i,j] <> 0 then
    begin
      l:= Tablero[i,j];
      Tablero[i,j]:= 0;
      if Obvio(Tablero,i,j)=0 then
        inc(k)
      else
        Tablero[i,j]:= l;
    end;
  end;
end;

function TableroValido(Tablero: TTablero): boolean;
var
  i,j,k: Integer;
begin
  for i:= 0 to NUM_COLUMNAS - 1 do
    for j:= 0 to NUM_FILAS - 1 do
    if Tablero[i,j] <> 0 then
      begin
        k:= Tablero[i,j];
        Tablero[i,j]:= 0;
        if not Valido(Tablero,i,j,k) then
        begin
          Tablero[i,j]:= k;
          Result:= FALSE;
          Exit;
        end;
        Tablero[i,j]:= k;
      end;
  Result:= TRUE;
end;

procedure TfrmMain.PaintTablero(Tablero: TTablero);
var
  i,j: Integer;
  Str: string;
begin
  for i := 0 to (NUM_COLUMNAS - 1) do
    for j := 0 to (NUM_FILAS - 1) do
    begin
      Str := IntToStr(Tablero[i,j]);
      if (Str = '0') then
        Str := '';
      grdTablero.Cells[i,j] := Str;
    end;
end;

procedure TfrmMain.StringGridToTablero(var Tablero: TTablero);
var
  i,j: Integer;
begin
  for i := 0 to (NUM_COLUMNAS - 1) do
    for j := 0 to (NUM_FILAS - 1) do
      Tablero[i,j] := StrToIntDef(Trim(grdTablero.Cells[i,j]), 0);
end;

procedure TfrmMain.Mensaje(Str: string);
begin
  Messagebox(Handle, PChar(Str), PChar(Application.Title),
    MB_OK or MB_ICONINFORMATION);
end;

function TfrmMain.TableroToString(Tablero: TTablero): string;
var
  i,j: integer;
begin
  Result:= '';
  for j := 0 to (NUM_COLUMNAS - 1) do
    for i := 0 to (NUM_FILAS - 1) do
      Result:= Result + IntToStr(Tablero[i,j]);
end;

procedure TfrmMain.StringToTablero(Str: string; var Tablero: TTablero);
var
  i: integer;
begin
  Fillchar(Tablero,Sizeof(Tablero),0);
  for i:= 0 to length(Str) -1 do
    Tablero[i mod NUM_COLUMNAS, i div NUM_COLUMNAS]:= StrToIntDef(Copy(Str,i+1,1),0);
end;

procedure TfrmMain.GuardarUndo;
var
  Tablero: TTablero;
  Str: string;
begin
  while UndoList.Count > 1000 do
    UndoList.Delete(1);
  StringGridToTablero(Tablero);
  Str:= TableroToString(Tablero);
  if UndoList.Count > 0 then
    if UndoList[UndoList.Count-1] = Str then
      Exit;
  UndoList.Add(Str);
end;

procedure TfrmMain.FormCreate(Sender: TObject);
begin
  UndoList := TStringList.Create();
  grdTablero.Top := 0;
  grdTablero.Left := 0;
  grdTablero.ScrollBars := ssNone;
  grdTablero.RowCount := NUM_FILAS;
  grdTablero.ColCount := NUM_FILAS;
  grdTablero.FixedCols := 0;
  grdTablero.FixedRows := 0;
  grdTablero.DefaultColWidth := grdTablero.Width div (NUM_COLUMNAS);
  grdTablero.DefaultRowHeight:= grdTablero.Height div (NUM_FILAS);
  ClientWidth:= grdTablero.Width + (grdTablero.GridLineWidth * NUM_COLUMNAS);
  ClientHeight:= grdTablero.Height + (grdTablero.GridLineWidth * NUM_FILAS);
  grdTablero.Width:= grdTablero.Width + grdTablero.DefaultColWidth;
  grdTablero.Height:= grdTablero.Height + grdTablero.DefaultRowHeight;
  grdTablero.Font.Name := 'Arial';
  grdTablero.Font.Size := 24;
  grdTablero.Font.Style := grdTablero.Canvas.Font.Style + [fsBold];
  GenerarTablero(TableroGenerado,0);
  PaintTablero(TableroGenerado);
  if ParamStr(1) <> '' then
    Cargar(ParamStr(1));
end;

procedure TfrmMain.FormDestroy(Sender: TObject);
begin
  FreeAndNil(UndoList);
end;

procedure TfrmMain.grdTableroDrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
begin
  with grdTablero, grdTablero.Canvas do
  begin
    if Odd((ACol div 3) + (ARow div 3)) then
      Brush.Color:= clYellow
    else
      Brush.Color:= clWhite;
    if TableroGenerado[ACol, ARow] > 0 then
      Font.Color:= clRed
    else
      Font.Color:= clBlack;
    ExtTextOut(Handle,
      (Rect.Left + Rect.Right - TextWidth(Cells[ACol,ARow])) div 2,
      (Rect.Top + Rect.Bottom - TextHeight(Cells[ACol,ARow])) div 2,
      ETO_CLIPPED	or ETO_OPAQUE	, @Rect, PChar(Cells[ACol,ARow]),
      Length(Cells[ACol,ARow]),nil);
  end;
end;

procedure TfrmMain.mnuNuevoClick(Sender: TObject);
begin
  Fillchar(TableroGenerado, Sizeof(TTablero), 0);
  PaintTablero(TableroGenerado);
  UndoList.Clear;
end;

procedure TfrmMain.mnuPrintClick(Sender: TObject);
const
  MargenX = 60;
  MargenY = 30;
  Lado    = 10;

var
  Tablero: TTablero;
  PPX, PPY, OX, OY: Integer;
  i, j: integer;
  R: TRect;
  Str: string;

  function ToPixelsX(const x: Real): Integer;
  begin
    Result:= Round((x / 25.4) * PPX) - OX;
  end;

  function ToPixelsY(const y: Real): Integer;
  begin
    Result:= Round((y / 25.4) * PPY) - OY;
  end;

begin
  StringGridToTablero(Tablero);
  with TPrintDialog.Create(nil) do
  try
    if Execute then
      with Printer, Printer.Canvas do
      begin
        Printer.Orientation := poPortrait;
        Printer.Canvas.Font.Size:= 16;
        Printer.Canvas.Brush.Style:= bsClear;
        BeginDoc;
        try
          PPX := GetDeviceCaps(Printer.Handle, LOGPIXELSX);
          PPY := GetDeviceCaps(Printer.Handle, LOGPIXELSY);
          OX := GetDeviceCaps(Printer.Handle, PHYSICALOFFSETX);
          OY := GetDeviceCaps(Printer.Handle, PHYSICALOFFSETY);
          for i:= 0 to NUM_COLUMNAS -1 do
            for j:= 0 to NUM_FILAS - 1 do
            begin
              R:= Rect(ToPixelsX((i*Lado) + MargenX),
                       ToPixelsY((j*Lado) + MargenY),
                       ToPixelsX((i*Lado) + MargenX + Lado),
                       ToPixelsY((j*Lado) + MargenY + Lado));
              if Odd((i div 3) + (j div 3)) then
                Brush.Color:= clYellow
              else
                Brush.Color:= clWhite;
              Rectangle(R);
              if Tablero[i,j] = 0 then
                Str:= #32
              else
                Str:= IntToStr(Tablero[i,j]);
              TextOut((R.Left + R.Right - TextWidth(Str)) div 2,
                (R.Top + R.Bottom - TextHeight(Str)) div 2, Str);
            end;
          EndDoc;
        except
          Abort;
        end;
      end;
  finally
    Free;
  end;
end;

procedure TfrmMain.mnuGenSencilloClick(Sender: TObject);
begin
  GenerarTablero(TableroGenerado,(Sender as TMenuItem).Tag);
  PaintTablero(TableroGenerado);
  UndoList.Clear;
end;

procedure TfrmMain.mnuReducirClick(Sender: TObject);
var
  Tablero:TTablero;
begin
  StringGridToTablero(Tablero);
  if TableroValido(Tablero) then
  begin
    GuardarUndo;
    Reducir(Tablero);
    PaintTablero(Tablero);
  end else Mensaje('Hay numeros mal colocados');
end;

procedure TfrmMain.mnuResolverClick(Sender: TObject);
var
  Tablero:TTablero;
begin
  StringGridToTablero(Tablero);
  if TableroValido(Tablero) then
  begin
    GuardarUndo;
    Resolver(Tablero);
    PaintTablero(Tablero);
  end else Mensaje('Hay numeros mal colocados');
end;

procedure TfrmMain.mnuSalirClick(Sender: TObject);
begin
  Close;
end;

procedure TfrmMain.grdTableroMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  ACol, ARow, i: Integer;
begin
  grdTablero.MouseToCell(x, y, ACol, ARow);
  if TableroGenerado[ACol, ARow] = 0 then
  begin
    if ssLeft in Shift then
    begin
      GuardarUndo;
      i:= StrToIntDef(grdTablero.Cells[ACol,ARow],0);
      i:= (i+1) mod 10;
      if i > 0 then
        grdTablero.Cells[ACol,ARow]:= IntToStr(i)
      else
        grdTablero.Cells[ACol,ARow]:= '';
    end;
    if ssRight in Shift then
    begin
      GuardarUndo;
      grdTablero.Cells[ACol,ARow]:= ''
    end;
  end;
end;

procedure TfrmMain.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  if Messagebox(Handle, 'Realmente deseas terminar el juego?',
    PChar(Application.Title), MB_YESNO or MB_ICONQUESTION) = IDNO then
  begin
    CanClose:= FALSE;
  end;
end;

procedure TfrmMain.mnuUndoClick(Sender: TObject);
var
  Tablero: TTablero;
begin
  if UndoList.Count > 0 then
  begin
    StringToTablero(UndoList[UndoList.Count - 1], Tablero);
    UndoList.Delete(UndoList.Count - 1);
    PaintTablero(Tablero);
  end;
end;

procedure TfrmMain.munAcercadeClick(Sender: TObject);
begin
  Mensaje
  (
   'Copyright (C) 2006 Domingo Seoane, dseoane@gmail.com'
  );
end;

procedure TfrmMain.mnuGuardarClick(Sender: TObject);
var
  Tablero: TTablero;
begin
  dlgSave.FileName:= FormatDateTime('ddhhmm',Now) + '.sdk';
  if dlgSave.Execute then
  with TStringList.Create do
  try
    AddStrings(UndoList);
    StringGridToTablero(Tablero);
    Add(TableroToString(Tablero));
    Add(TableroToString(TableroGenerado));
    SaveToFile(ChangeFileExt(dlgSave.FileName,'.sdk'));
  finally
    Free;
  end;
end;

procedure TfrmMain.Cargar(Filename: string);
var
  Tablero: TTablero;
  i,j: Integer;
begin
  with TStringList.Create do
  try
    try
      LoadFromFile(FileName);
      for i:= 0 to Count - 1 do
      begin
        if Length(Strings[i]) > NUM_COLUMNAS * NUM_FILAS then
          raise Exception.Create('');
        for j:= 1 to length(Strings[i]) do
          if not (Strings[i][j] in ['0'..'9',' ']) then
            raise Exception.Create('');
      end;
      FillChar(TableroGenerado,Sizeof(TTablero),0);
      if Count > 0 then
      begin
        StringToTablero(Strings[Count-1],TableroGenerado);
        Delete(Count-1);
      end;
      if Count > 0 then
      begin
        StringToTablero(Strings[Count-1],Tablero);
        PaintTablero(Tablero);
        Delete(Count-1);
      end;
      UndoList.Text:= Text;
    except
      Mensaje('No puedo abrir esta partida guardada');
    end;
  finally
    Free;
  end;
end;

procedure TfrmMain.mnuAbrirClick(Sender: TObject);
begin
  dlgOpen.FileName:= '';
  if dlgOpen.Execute then
    Cargar(dlgOpen.FileName);
end;

procedure TfrmMain.mnuComprobarClick(Sender: TObject);
var
  Tablero:TTablero;
begin
  StringGridToTablero(Tablero);
  if TableroValido(Tablero) then
    if Resolver(Tablero) then
    begin
      Mensaje('Todos los numeros estan bien colocados');
    end else
    begin
      Mensaje('Vuelve sobre tus pasos, por este camnio no hay solucion');
    end
  else
  begin
    Mensaje('Hay numeros mal colocados');
  end;
end;

procedure TfrmMain.mnuAyudameClick(Sender: TObject);
var
  Tablero:TTablero;
begin
  StringGridToTablero(Tablero);
  if TableroValido(Tablero) then
  begin
    GuardarUndo;
    if not Ayudita(Tablero) then
      Mensaje('Lo siento, pero no puedo hacer nada mas.')
    else
      PaintTablero(Tablero);
  end else Mensaje('Hay numeros mal colocados')
end;

end.
